ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.24 by greg, Tue Aug 23 14:02:41 2011 UTC vs.
Revision 2.69 by greg, Fri Sep 16 22:42:42 2016 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + my $windoz = ($^O eq "MSWin32" or $^O eq "MSWin64");
10   use File::Temp qw/ :mktemp  /;
11   sub userror {
12 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-W][-t{3|4} Nlog2][-r \"ropts\"][-s \"x=string;y=string\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}C][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
13          exit 1;
14   }
15 < my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
16 < chomp $td;
15 > my ($td,$radscn,$mgfscn,$octree,$fsender,$bsender,$receivers,$facedat,$behinddat,$rmtmp);
16 > my ($tf,$rf,$tb,$rb,$tfx,$rfx,$tbx,$rbx,$tfz,$rfz,$tbz,$rbz,$cph);
17 > my ($curphase, $recovery);
18 > if ($#ARGV == 1 && "$ARGV[0]" =~ /^-rec/) {
19 >        $td = $ARGV[1];
20 >        open(MYAVH, "< $td/savedARGV.txt") or die "$td: invalid path\n";
21 >        @ARGV = <MYAVH>;
22 >        close MYAVH;
23 >        chomp @ARGV;
24 >        $recovery = 0;
25 >        if (open(MYPH, "< $td/phase.txt")) {
26 >                while (<MYPH>) {
27 >                        chomp($recovery = $_);
28 >                }
29 >                close MYPH;
30 >        }
31 > } elsif ($windoz) {
32 >        my $tmploc = `echo \%TMP\%`;
33 >        chomp $tmploc;
34 >        $td = mkdtemp("$tmploc\\genBSDF.XXXXXX");
35 > } else {
36 >        $td = mkdtemp("/tmp/genBSDF.XXXXXX");
37 >        chomp $td;
38 > }
39 > if ($windoz) {
40 >        $radscn = "$td\\device.rad";
41 >        $mgfscn = "$td\\device.mgf";
42 >        $octree = "$td\\device.oct";
43 >        $fsender = "$td\\fsender.rad";
44 >        $bsender = "$td\\bsender.rad";
45 >        $receivers = "$td\\receivers.rad";
46 >        $facedat = "$td\\face.dat";
47 >        $behinddat = "$td\\behind.dat";
48 >        $tf = "$td\\tf.dat";
49 >        $rf = "$td\\rf.dat";
50 >        $tb = "$td\\tb.dat";
51 >        $rb = "$td\\rb.dat";
52 >        $tfx = "$td\\tfx.dat";
53 >        $rfx = "$td\\rfx.dat";
54 >        $tbx = "$td\\tbx.dat";
55 >        $rbx = "$td\\rbx.dat";
56 >        $tfz = "$td\\tfz.dat";
57 >        $rfz = "$td\\rfz.dat";
58 >        $tbz = "$td\\tbz.dat";
59 >        $rbz = "$td\\rbz.dat";
60 >        $cph = "$td\\phase.txt";
61 >        $rmtmp = "rd /S /Q $td";
62 > } else {
63 >        $radscn = "$td/device.rad";
64 >        $mgfscn = "$td/device.mgf";
65 >        $octree = "$td/device.oct";
66 >        $fsender = "$td/fsender.rad";
67 >        $bsender = "$td/bsender.rad";
68 >        $receivers = "$td/receivers.rad";
69 >        $facedat = "$td/face.dat";
70 >        $behinddat = "$td/behind.dat";
71 >        $tf = "$td/tf.dat";
72 >        $rf = "$td/rf.dat";
73 >        $tb = "$td/tb.dat";
74 >        $rb = "$td/rb.dat";
75 >        $tfx = "$td/tfx.dat";
76 >        $rfx = "$td/rfx.dat";
77 >        $tbx = "$td/tbx.dat";
78 >        $rbx = "$td/rbx.dat";
79 >        $tfz = "$td/tfz.dat";
80 >        $rfz = "$td/rfz.dat";
81 >        $tbz = "$td/tbz.dat";
82 >        $rbz = "$td/rbz.dat";
83 >        $cph = "$td/phase.txt";
84 >        $rmtmp = "rm -rf $td";
85 > }
86   my @savedARGV = @ARGV;
87 + my $rfluxmtx = "rfluxmtx -ab 5 -ad 700 -lw 3e-6";
88 + my $wrapper = "wrapBSDF";
89   my $tensortree = 0;
90   my $ttlog2 = 4;
91 < my $nsamp = 10000;
20 < my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
91 > my $nsamp = 2000;
92   my $mgfin = 0;
93   my $geout = 1;
94   my $nproc = 1;
95 + my $docolor = 0;
96   my $doforw = 0;
97   my $doback = 1;
98 < my $gunit = "Meter";
98 > my $pctcull = 90;
99 > my $gunit = "meter";
100 > my $curspec = "Visible";
101   my @dim;
102   # Get options
103   while ($#ARGV >= 0) {
104          if ("$ARGV[0]" =~ /^[-+]m/) {
105                  $mgfin = ("$ARGV[0]" =~ /^\+/);
106          } elsif ("$ARGV[0]" eq "-r") {
107 <                $rtargs = "$rtargs $ARGV[1]";
107 >                $rfluxmtx .= " $ARGV[1]";
108                  shift @ARGV;
109          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
110                  $geout = ("$ARGV[0]" =~ /^\+/);
# Line 39 | Line 113 | while ($#ARGV >= 0) {
113                          die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
114                  }
115                  shift @ARGV;
116 +        } elsif ("$ARGV[0]" =~ /^[-+]C/) {
117 +                $docolor = ("$ARGV[0]" =~ /^\+/);
118          } elsif ("$ARGV[0]" =~ /^[-+]f/) {
119                  $doforw = ("$ARGV[0]" =~ /^\+/);
120          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
121                  $doback = ("$ARGV[0]" =~ /^\+/);
122 +        } elsif ("$ARGV[0]" eq "-t") {
123 +                # Use value < 0 for rttree_reduce bypass
124 +                $pctcull = $ARGV[1];
125 +                if ($pctcull >= 100) {
126 +                        die "Illegal -t culling percentage, must be < 100\n";
127 +                }
128 +                shift @ARGV;
129          } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
130                  $tensortree = substr($ARGV[0], 2, 1);
131                  $ttlog2 = $ARGV[1];
132                  shift @ARGV;
133 +        } elsif ("$ARGV[0]" eq "-s") {
134 +                $wrapper .= " -f \"$ARGV[1]\"";
135 +                shift @ARGV;
136 +        } elsif ("$ARGV[0]" eq "-W") {
137 +                $wrapper .= " -W";
138          } elsif ("$ARGV[0]" eq "-c") {
139                  $nsamp = $ARGV[1];
140                  shift @ARGV;
# Line 66 | Line 154 | while ($#ARGV >= 0) {
154   }
155   # Check that we're actually being asked to do something
156   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
157 < # Name our own persist file?
158 < my $persistfile;
159 < if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
160 <        $persistfile = "$td/pfile.txt";
161 <        $rtargs = "-PP $persistfile $rtargs";
157 > $wrapper .= $tensortree ? " -a t$tensortree" : " -a kf -c";
158 > $wrapper .= " -u $gunit";
159 > if ( !defined $recovery ) {
160 >        # Issue warning for unhandled reciprocity case
161 >        print STDERR "Warning: recommend both +forward and +backward with -t3\n" if
162 >                        ($tensortree==3 && !($doforw && $doback));
163 >        # Get scene description
164 >        if ( $mgfin ) {
165 >                system "mgf2rad @ARGV > $radscn";
166 >                die "Could not load MGF input\n" if ( $? );
167 >        } else {
168 >                system "xform -e @ARGV > $radscn";
169 >                die "Could not load Radiance input\n" if ( $? );
170 >        }
171   }
172 < # Get scene description and dimensions
76 < my $radscn = "$td/device.rad";
77 < my $mgfscn = "$td/device.mgf";
78 < my $octree = "$td/device.oct";
79 < if ( $mgfin ) {
80 <        system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
81 <        die "Could not load MGF input\n" if ( $? );
82 <        system "mgf2rad $mgfscn > $radscn";
83 < } else {
84 <        system "xform -e @ARGV > $radscn";
85 <        die "Could not load Radiance input\n" if ( $? );
86 <        system "rad2mgf $radscn > $mgfscn" if ( $geout );
87 < }
88 < if ($#dim != 5) {
172 > if ( $#dim != 5 ) {
173          @dim = split ' ', `getbbox -h $radscn`;
174   }
175 < print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
176 < # Add receiver surfaces (rectangular)
177 < my $fmodnm="receiver_face";
178 < my $bmodnm="receiver_behind";
179 < open(RADSCN, ">> $radscn");
96 < print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
97 < print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
98 < print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
99 < print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
100 < close RADSCN;
101 < # Generate octree
102 < system "oconv -w $radscn > $octree";
103 < die "Could not compile scene\n" if ( $? );
104 < # Output XML prologue
105 < print
106 < '<?xml version="1.0" encoding="UTF-8"?>
107 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
108 < ';
109 < print "<!-- File produced by: genBSDF @savedARGV -->\n";
110 < print
111 < '<WindowElementType>System</WindowElementType>
112 < <Optical>
113 < <Layer>
114 <        <Material>
115 <                <Name>Name</Name>
116 <                <Manufacturer>Manufacturer</Manufacturer>
117 < ';
118 < printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
119 < printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
120 < printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
121 < print "\t\t<DeviceType>Integral</DeviceType>\n";
122 < # Output MGF description if requested
123 < if ( $geout ) {
124 <        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
125 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
126 <        open(MGFSCN, "< $mgfscn");
127 <        while (<MGFSCN>) { print $_; }
128 <        close MGFSCN;
129 <        print "xf\n";
130 <        print "\t\t</Geometry>\n";
175 > die "Device entirely inside room!\n" if ( $dim[4] >= 0 );
176 > if ( $dim[5] > 1e-5 ) {
177 >        print STDERR "Warning: Device extends into room\n";
178 > } elsif ( $dim[5]*$dim[5] > .01*($dim[1]-$dim[0])*($dim[3]-$dim[2]) ) {
179 >        print STDERR "Warning: Device far behind Z==0 plane\n";
180   }
181 < print " </Material>\n";
182 < # Set up surface sampling
183 < my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
184 < my $ny = int($nsamp/$nx + .5);
185 < $nsamp = $nx * $ny;
181 > # Assume Zmax==0 to derive thickness so pkgBSDF will work
182 > $wrapper .= ' -f "t=' . (-$dim[4]) . ';w=' . ($dim[1] - $dim[0]) .
183 >                ';h=' . ($dim[3] - $dim[2]) . '"';
184 > $wrapper .= " -g $mgfscn" if ( $geout );
185 > # Calculate CIE (u',v') from Radiance RGB:
186 > my $CIEuv =     'Xi=.5141*Ri+.3239*Gi+.1620*Bi;' .
187 >                'Yi=.2651*Ri+.6701*Gi+.0648*Bi;' .
188 >                'Zi=.0241*Ri+.1229*Gi+.8530*Bi;' .
189 >                'den=Xi+15*Yi+3*Zi;' .
190 >                'uprime=4*Xi/den;vprime=9*Yi/den;' ;
191 > my $FEPS = 1e-5;
192   my $ns = 2**$ttlog2;
193 < my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
193 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + 1);
194 > my $ny = int($nsamp/$nx + 1);
195 > $nsamp = $nx * $ny;
196 > $rfluxmtx .= " -n $nproc -c $nsamp";
197 > if ( !defined $recovery ) {
198 >        open(MYAVH, "> $td/savedARGV.txt");
199 >        foreach (@savedARGV) {
200 >                print MYAVH "$_\n";
201 >        }
202 >        close MYAVH;
203 >        # Generate octree
204 >        system "oconv -w $radscn > $octree";
205 >        die "Could not compile scene\n" if ( $? );
206 >        # Add MGF description if requested
207 >        if ( $geout ) {
208 >                open(MGFSCN, "> $mgfscn");
209 >                printf MGFSCN "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
210 >                close MGFSCN;
211 >                if ( $mgfin ) {
212 >                        system qq{mgfilt "#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus" @ARGV >> $mgfscn};
213 >                } else {
214 >                        system "rad2mgf $radscn >> $mgfscn";
215 >                }
216 >                open(MGFSCN, ">> $mgfscn");
217 >                print MGFSCN "xf\n";
218 >                close MGFSCN;
219 >        }
220 >        # Create receiver & sender surfaces (rectangular)
221 >        open(RADSCN, "> $receivers");
222 >        print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=-sc$ns\n" : "h=-kf\n");
223 >        print RADSCN '#@rfluxmtx ' . "u=-Y o=$facedat\n\n";
224 >        print RADSCN "void glow receiver_face\n0\n0\n4 1 1 1 0\n\n";
225 >        print RADSCN "receiver_face source f_receiver\n0\n0\n4 0 0 1 180\n\n";
226 >        print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=+sc$ns\n" : "h=+kf\n");
227 >        print RADSCN '#@rfluxmtx ' . "u=-Y o=$behinddat\n\n";
228 >        print RADSCN "void glow receiver_behind\n0\n0\n4 1 1 1 0\n\n";
229 >        print RADSCN "receiver_behind source b_receiver\n0\n0\n4 0 0 -1 180\n";
230 >        close RADSCN;
231 >        # Prepare sender surfaces
232 >        if ( $tensortree != 3 ) {       # Isotropic tensor tree is exception
233 >                open (RADSCN, "> $fsender");
234 >                print RADSCN '#@rfluxmtx u=-Y ' . ($tensortree ? "h=-sc$ns\n\n" : "h=-kf\n\n");
235 >                print RADSCN "void polygon fwd_sender\n0\n0\n12\n";
236 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[2], $dim[4]-$FEPS;
237 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[3], $dim[4]-$FEPS;
238 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[3], $dim[4]-$FEPS;
239 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[2], $dim[4]-$FEPS;
240 >                close RADSCN;
241 >                open (RADSCN, "> $bsender");
242 >                print RADSCN '#@rfluxmtx u=-Y ' . ($tensortree ? "h=+sc$ns\n\n" : "h=+kf\n\n");
243 >                print RADSCN "void polygon bwd_sender\n0\n0\n12\n";
244 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[2], $dim[5]+$FEPS;
245 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[2], $dim[5]+$FEPS;
246 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[3], $dim[5]+$FEPS;
247 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[3], $dim[5]+$FEPS;
248 >                close RADSCN;
249 >        }
250 >        print STDERR "Recover using: $0 -recover $td\n";
251 > }
252 > # Open unbuffered progress file
253 > open(MYPH, ">> $td/phase.txt");
254 > {
255 >        my $ofh = select MYPH;
256 >        $| = 1;
257 >        select $ofh;
258 > }
259 > $curphase = 0;
260   # Create data segments (all the work happens here)
261   if ( $tensortree ) {
262          do_tree_bsdf();
263   } else {
264          do_matrix_bsdf();
265   }
266 < # Output XML epilogue
267 < print
268 < '</Layer>
269 < </Optical>
149 < </WindowElement>
150 < ';
266 > # Output XML
267 > # print STDERR "Running: $wrapper\n";
268 > system "$wrapper -C \"Created by: genBSDF @savedARGV\"";
269 > die "Could not wrap BSDF data\n" if ( $? );
270   # Clean up temporary files and exit
271 < if ( $persistfile && open(PFI, "< $persistfile") ) {
272 <        while (<PFI>) {
273 <                s/^[^ ]* //;
274 <                kill('ALRM', $_);
275 <                last;
271 > exec $rmtmp;
272 >
273 > #============== End of main program segment ==============#
274 >
275 > # Function to determine if next phase should be skipped or recovered
276 > sub do_phase {
277 >        $curphase++;
278 >        if (defined $recovery) {
279 >                if ($recovery > $curphase) { return 0; }
280 >                if ($recovery == $curphase) { return -1; }
281          }
282 <        close PFI;
282 >        print MYPH "$curphase\n";
283 >        return 1;
284   }
160 exec("rm -rf $td");
285  
162 #-------------- End of main program segment --------------#
163
286   #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
287   sub do_tree_bsdf {
288 < # Get sampling rate and subdivide task
289 < my $ns2 = $ns;
290 < $ns2 /= 2 if ( $tensortree == 3 );
291 < my $nsplice = $nproc;
292 < $nsplice *= 10 if ($nproc > 1);
171 < $nsplice = $ns2 if ($nsplice > $ns2);
172 < $nsplice = 999 if ($nsplice > 999);
173 < @pdiv = (0, int($ns2/$nsplice));
174 < my $nrem = $ns2 % $nsplice;
175 < for (my $i = 1; $i < $nsplice; $i++) {
176 <        my $nv = $pdiv[$i] + $pdiv[1];
177 <        ++$nv if ( $nrem-- > 0 );
178 <        push @pdiv, $nv;
179 < }
180 < die "Script error 1" if ($pdiv[-1] != $ns2);
181 < # Shirley-Chiu mapping from unit square to disk
182 < $sq2disk = '
183 < in_square_a = 2*in_square_x - 1;
184 < in_square_b = 2*in_square_y - 1;
185 < in_square_rgn = if(in_square_a + in_square_b,
186 <                        if(in_square_a - in_square_b, 1, 2),
187 <                        if(in_square_b - in_square_a, 3, 4));
188 < out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
189 <                        -in_square_a, -in_square_b);
190 < out_disk_phi = PI/4 * select(in_square_rgn,
191 <                                in_square_b/in_square_a,
192 <                                2 - in_square_a/in_square_b,
193 <                                4 + in_square_b/in_square_a,
194 <                                if(in_square_b*in_square_b,
195 <                                        6 - in_square_a/in_square_b, 0));
196 < Dx = out_disk_r*cos(out_disk_phi);
197 < Dy = out_disk_r*sin(out_disk_phi);
198 < Dz = sqrt(1 - out_disk_r*out_disk_r);
199 < ';
200 < # Shirley-Chiu mapping from unit disk to square
201 < $disk2sq = '
202 < norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
203 < in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
204 < in_disk_phi = norm_radians(atan2(Dy, Dx));
205 < in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
206 < out_square_a = select(in_disk_rgn,
207 <                        in_disk_r,
208 <                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
209 <                        -in_disk_r,
210 <                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
211 < out_square_b = select(in_disk_rgn,
212 <                        in_disk_phi*in_disk_r/(PI/4),
213 <                        in_disk_r,
214 <                        (PI - in_disk_phi)*in_disk_r/(PI/4),
215 <                        -in_disk_r);
216 < out_square_x = (out_square_a + 1)/2;
217 < out_square_y = (out_square_b + 1)/2;
218 < ';
219 < # Announce ourselves in XML output
220 < print "\t<DataDefinition>\n";
221 < print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
222 < print "\t</DataDefinition>\n";
223 < # Fork parallel rtcontrib processes to compute each side
224 < my $npleft = $nproc;
225 < if ( $doback ) {
226 <        for (my $splice = 0; $splice < $nsplice; $splice++) {
227 <                if (! $npleft ) {
228 <                        wait();
229 <                        die "rtcontrib process reported error" if ( $? );
230 <                        $npleft++;
231 <                }
232 <                bg_tree_rtcontrib(0, $splice);
233 <                $npleft--;
234 <        }
235 <        while (wait() >= 0) {
236 <                die "rtcontrib process reported error" if ( $? );
237 <                $npleft++;
238 <        }
239 <        ttree_out(0);
240 < }
241 < if ( $doforw ) {
242 <        for (my $splice = 0; $splice < $nsplice; $splice++) {
243 <                if (! $npleft ) {
244 <                        wait();
245 <                        die "rtcontrib process reported error" if ( $? );
246 <                        $npleft++;
247 <                }
248 <                bg_tree_rtcontrib(1, $splice);
249 <                $npleft--;
250 <        }
251 <        while (wait() >= 0) {
252 <                die "rtcontrib process reported error" if ( $? );
253 <                $npleft++;
254 <        }
255 <        ttree_out(1);
256 < }
288 >
289 >        # Run rfluxmtx processes to compute each side
290 >        do_ttree_dir(0) if ( $doback );
291 >        do_ttree_dir(1) if ( $doforw );
292 >
293   }       # end of sub do_tree_bsdf()
294  
295 < # Run rtcontrib process in background to generate tensor tree samples
296 < sub bg_tree_rtcontrib {
261 <        my $pid = fork();
262 <        die "Cannot fork new process" unless defined $pid;
263 <        if ($pid > 0) { return $pid; }
295 > # Call rfluxmtx and process tensor tree BSDF for the given direction
296 > sub do_ttree_dir {
297          my $forw = shift;
298 <        my $pn = shift;
299 <        my $pbeg = $pdiv[$pn];
300 <        my $plen = $pdiv[$pn+1] - $pbeg;
301 <        my $matargs = "-m $bmodnm";
269 <        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
270 <        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
271 <                "-e '$disk2sq' -bn '$ns*$ns' " .
272 <                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
273 <                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
298 >        my $r = do_phase();
299 >        if (!$r) { return; }
300 >        $r = ($r < 0) ? " -r" : "";
301 >        my $cmd;
302          if ( $tensortree == 3 ) {
303                  # Isotropic BSDF
304 <                $cmd = "cnt $plen $ny $nx " .
305 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
306 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
307 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
308 <                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
309 <                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
310 <                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
311 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
312 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
313 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
314 <                        "| $cmd";
304 >                my $ns2 = $ns / 2;
305 >                if ($windoz) {
306 >                        $cmd = "cnt $ns2 $ny $nx " .
307 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
308 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
309 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
310 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
311 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
312 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
313 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
314 >                                qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
315 >                                qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
316 >                                "| $rfluxmtx$r -fa -y $ns2 - $receivers -i $octree";
317 >                } else {
318 >                        $cmd = "cnt $ns2 $ny $nx " .
319 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
320 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
321 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
322 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
323 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
324 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
325 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
326 >                                qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
327 >                                qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
328 >                                "| $rfluxmtx$r -h -ff -y $ns2 - $receivers -i $octree";
329 >                }
330          } else {
331                  # Anisotropic BSDF
332 <                # Sample area vertically to improve load balance, since
333 <                # shading systems usually have bilateral symmetry (L-R)
334 <                $cmd = "cnt $plen $ns $ny $nx " .
335 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
336 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
337 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
295 <                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
296 <                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
297 <                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
298 <                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
299 <                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
300 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
301 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
302 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
303 <                        "| $cmd";
332 >                my $sender = ($bsender,$fsender)[$forw];
333 >                if ($windoz) {
334 >                        $cmd = "$rfluxmtx$r -fa $sender $receivers -i $octree";
335 >                } else {
336 >                        $cmd = "$rfluxmtx$r -h -ff $sender $receivers -i $octree";
337 >                }
338          }
339 < # print STDERR "Starting: $cmd\n";
340 <        exec($cmd);             # no return; status report to parent via wait
341 <        die "Cannot exec: $cmd\n";
342 < }       # end of bg_tree_rtcontrib()
339 >        # print STDERR "Starting: $cmd\n";
340 >        system $cmd;
341 >        die "Failure running rfluxmtx" if ( $? );
342 >        ttree_out($forw);
343 > }       # end of do_ttree_dir()
344  
345 < # Simplify and output tensor tree results
345 > # Simplify and store tensor tree results
346   sub ttree_out {
347          my $forw = shift;
348 <        my $side = ("Back","Front")[$forw];
349 < # Only output one transmitted distribution, preferring backwards
350 < if ( !$forw || !$doback ) {
351 < print
352 < '       <WavelengthData>
353 <                <LayerNumber>System</LayerNumber>
354 <                <Wavelength unit="Integral">Visible</Wavelength>
355 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
356 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
357 <                <WavelengthDataBlock>
358 <                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
359 <                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
360 <                        <ScatteringDataType>BTDF</ScatteringDataType>
361 <                        <ScatteringData>
362 < ';
363 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
364 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
365 <        "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
366 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
367 < die "Failure running rttree_reduce" if ( $? );
368 < print
369 < '                       </ScatteringData>
370 <                </WavelengthDataBlock>
371 <        </WavelengthData>
337 < ';
338 < }
339 < # Output reflection
340 < print
341 < '       <WavelengthData>
342 <                <LayerNumber>System</LayerNumber>
343 <                <Wavelength unit="Integral">Visible</Wavelength>
344 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
345 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
346 <                <WavelengthDataBlock>
347 < ';
348 < print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
349 < print
350 < '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
351 <                        <ScatteringDataType>BRDF</ScatteringDataType>
352 <                        <ScatteringData>
353 < ';
354 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
355 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
356 <        "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
357 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
358 < die "Failure running rttree_reduce" if ( $? );
359 < print
360 < '                       </ScatteringData>
361 <                </WavelengthDataBlock>
362 <        </WavelengthData>
363 < ';
348 >        my ($refldat,$transdat);
349 >        if ( $forw ) {
350 >                $transdat = $facedat;
351 >                $refldat = $behinddat;
352 >        } else {
353 >                $transdat = $behinddat;
354 >                $refldat = $facedat;
355 >        }
356 >        # Only output one transmitted anisotropic distribution, preferring backwards
357 >        if ( !$forw || !$doback || $tensortree==3 ) {
358 >                my $ttyp = ("tb","tf")[$forw];
359 >                ttree_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
360 >                if ( $docolor ) {
361 >                        ttree_comp($ttyp, "CIE-u", $transdat, ($tbx,$tfx)[$forw]);
362 >                        ttree_comp($ttyp, "CIE-v", $transdat, ($tbz,$tfz)[$forw]);
363 >                }
364 >        }
365 >        # Output reflection
366 >        my $rtyp = ("rb","rf")[$forw];
367 >        ttree_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
368 >        if ( $docolor ) {
369 >                ttree_comp($rtyp, "CIE-u", $refldat, ($rbx,$rfx)[$forw]);
370 >                ttree_comp($rtyp, "CIE-v", $refldat, ($rbz,$rfz)[$forw]);
371 >        }
372   }       # end of ttree_out()
373  
374 + # Call rttree_reduce on the given component
375 + sub ttree_comp {
376 +        my $typ = shift;
377 +        my $spec = shift;
378 +        my $src = shift;
379 +        my $dest = shift;
380 +        my $cmd;
381 +        if ($windoz) {
382 +                if ("$spec" eq "Visible") {
383 +                        $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
384 +                                q{-e "Ri=$1;Gi=$2;Bi=$3" } .
385 +                                qq{-e "$CIEuv" } .
386 +                                q{-e "$1=Yi/Omega"};
387 +                } elsif ("$spec" eq "CIE-u") {
388 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
389 +                                qq{-e "$CIEuv" } .
390 +                                q{-e "$1=uprime"};
391 +                } elsif ("$spec" eq "CIE-v") {
392 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
393 +                                qq{-e "$CIEuv" } .
394 +                                q{-e "$1=vprime"};
395 +                }
396 +        } else {
397 +                if ("$spec" eq "Visible") {
398 +                        $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
399 +                                q{-e 'Ri=$1;Gi=$2;Bi=$3' } .
400 +                                "-e '$CIEuv' " .
401 +                                q{-e '$1=Yi/Omega'};
402 +                } elsif ("$spec" eq "CIE-u") {
403 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
404 +                                "-e '$CIEuv' " .
405 +                                q{-e '$1=uprime'};
406 +                } elsif ("$spec" eq "CIE-v") {
407 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
408 +                                "-e '$CIEuv' " .
409 +                                q{-e '$1=vprime'};
410 +                }
411 +        }
412 +        if ($pctcull >= 0) {
413 +                my $avg = ( "$typ" =~ /^r[fb]/ ) ? " -a" : "";
414 +                my $pcull = ("$spec" eq "Visible") ? $pctcull :
415 +                                                     (100 - (100-$pctcull)*.25) ;
416 +                if ($windoz) {
417 +                        $cmd = "rcollate -ho -oc 1 $src | " .
418 +                                        $cmd .
419 +                                        " | rttree_reduce$avg -h -fa -t $pcull -r $tensortree -g $ttlog2";
420 +                } else {
421 +                        $cmd .= " -of $src " .
422 +                                        "| rttree_reduce$avg -h -ff -t $pcull -r $tensortree -g $ttlog2";
423 +                }
424 +                # print STDERR "Running: $cmd\n";
425 +                system "$cmd > $dest";
426 +                die "Failure running rttree_reduce" if ( $? );
427 +        } else {
428 +                if ($windoz) {
429 +                        $cmd = "rcollate -ho -oc 1 $src | " . $cmd ;
430 +                } else {
431 +                        $cmd .= " $src";
432 +                }
433 +                open(DATOUT, "> $dest");
434 +                print DATOUT "{\n";
435 +                close DATOUT;
436 +                # print STDERR "Running: $cmd\n";
437 +                system "$cmd >> $dest";
438 +                die "Failure running rcalc" if ( $? );
439 +                open(DATOUT, ">> $dest");
440 +                for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
441 +                        print DATOUT "0\n";
442 +                }
443 +                print DATOUT "}\n";
444 +                close DATOUT;
445 +        }
446 +        if ( "$spec" ne "$curspec" ) {
447 +                $wrapper .= " -s $spec";
448 +                $curspec = $spec;
449 +        }
450 +        $wrapper .= " -$typ $dest";
451 + }       # end of ttree_comp()
452 +
453   #------------- End of do_tree_bsdf() & subroutines -------------#
454  
455   #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
456   sub do_matrix_bsdf {
457 < # Set up sampling of portal
458 < # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
459 < $tcal = '
460 < DEGREE : PI/180;
461 < sq(x) : x*x;
462 < Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
463 < Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
464 < Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
465 < Kmax : Kaccum(Knaz(0));
466 < Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
467 < Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
468 < Kcol = Kbin - Kaccum(Krow-1);
469 < Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
470 < Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
471 < sin_kpol = sin(Kpol);
472 < Dx = cos(Kazi)*sin_kpol;
473 < Dy = sin(Kazi)*sin_kpol;
474 < Dz = sqrt(1 - sin_kpol*sin_kpol);
475 < KprojOmega = PI * if(Kbin-.5,
476 <        (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
477 <        1 - sq(cos(Kpola(1)*DEGREE)));
478 < ';
479 < # Compute Klems bin from exiting ray direction (forward or backward)
480 < $kcal = '
481 < DEGREE : PI/180;
482 < abs(x) : if(x, x, -x);
483 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
484 < posangle(a) : if(-a, a + 2*PI, a);
485 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
486 < kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
487 < knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
401 < kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
402 < kfindrow(r, pol) : if(r-kpola(0)+.5, r,
403 <                if(pol-kpola(r), kfindrow(r+1, pol), r) );
404 < kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
405 < kbin2(pol,azi) = select(kfindrow(1, pol),
406 <                kazn(azi,360/knaz(1)),
407 <                kaccum(1) + kazn(azi,360/knaz(2)),
408 <                kaccum(2) + kazn(azi,360/knaz(3)),
409 <                kaccum(3) + kazn(azi,360/knaz(4)),
410 <                kaccum(4) + kazn(azi,360/knaz(5)),
411 <                kaccum(5) + kazn(azi,360/knaz(6)),
412 <                kaccum(6) + kazn(azi,360/knaz(7)),
413 <                kaccum(7) + kazn(azi,360/knaz(8)),
414 <                kaccum(8) + kazn(azi,360/knaz(9))
415 <        );
416 < kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
417 < ';
418 < my $ndiv = 145;
419 < # Compute scattering data using rtcontrib
420 < my @tfarr;
421 < my @rfarr;
422 < my @tbarr;
423 < my @rbarr;
424 < my $cmd;
425 < my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
426 <        "-e '$kcal' -b kbin -bn $ndiv " .
427 <        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
428 < my $rccmd = "rcalc -e '$tcal' " .
429 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
430 <        q{-if3 -e 'oval=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' } .
431 <        q[-o '${  oval  },'];
432 < if ( $doforw ) {
433 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
434 <        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
435 <        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
436 <        "-e 'zp:$dim[4]' " .
437 <        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
438 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
439 <        "| $rtcmd";
440 < system "$cmd" || die "Failure running: $cmd\n";
441 < @tfarr = `$rccmd $td/$fmodnm.flt`;
442 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
443 < @rfarr = `$rccmd $td/$bmodnm.flt`;
444 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
445 < }
446 < if ( $doback ) {
447 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
448 <        "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
449 <        "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
450 <        "-e 'zp:$dim[5]' " .
451 <        q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
452 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
453 <        "| $rtcmd";
454 < system "$cmd" || die "Failure running: $cmd\n";
455 < @tbarr = `$rccmd $td/$bmodnm.flt`;
456 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
457 < @rbarr = `$rccmd $td/$fmodnm.flt`;
458 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
459 < }
460 < # Output angle basis
461 < print
462 < '       <DataDefinition>
463 <                <IncidentDataStructure>Columns</IncidentDataStructure>
464 <                <AngleBasis>
465 <                        <AngleBasisName>LBNL/Klems Full</AngleBasisName>
466 <                        <AngleBasisBlock>
467 <                                <Theta>0</Theta>
468 <                                <nPhis>1</nPhis>
469 <                                <ThetaBounds>
470 <                                        <LowerTheta>0</LowerTheta>
471 <                                        <UpperTheta>5</UpperTheta>
472 <                                </ThetaBounds>
473 <                                </AngleBasisBlock>
474 <                                <AngleBasisBlock>
475 <                                <Theta>10</Theta>
476 <                                <nPhis>8</nPhis>
477 <                                <ThetaBounds>
478 <                                        <LowerTheta>5</LowerTheta>
479 <                                        <UpperTheta>15</UpperTheta>
480 <                                </ThetaBounds>
481 <                                </AngleBasisBlock>
482 <                                <AngleBasisBlock>
483 <                                <Theta>20</Theta>
484 <                                <nPhis>16</nPhis>
485 <                                <ThetaBounds>
486 <                                        <LowerTheta>15</LowerTheta>
487 <                                        <UpperTheta>25</UpperTheta>
488 <                                </ThetaBounds>
489 <                                </AngleBasisBlock>
490 <                                <AngleBasisBlock>
491 <                                <Theta>30</Theta>
492 <                                <nPhis>20</nPhis>
493 <                                <ThetaBounds>
494 <                                        <LowerTheta>25</LowerTheta>
495 <                                        <UpperTheta>35</UpperTheta>
496 <                                </ThetaBounds>
497 <                                </AngleBasisBlock>
498 <                                <AngleBasisBlock>
499 <                                <Theta>40</Theta>
500 <                                <nPhis>24</nPhis>
501 <                                <ThetaBounds>
502 <                                        <LowerTheta>35</LowerTheta>
503 <                                        <UpperTheta>45</UpperTheta>
504 <                                </ThetaBounds>
505 <                                </AngleBasisBlock>
506 <                                <AngleBasisBlock>
507 <                                <Theta>50</Theta>
508 <                                <nPhis>24</nPhis>
509 <                                <ThetaBounds>
510 <                                        <LowerTheta>45</LowerTheta>
511 <                                        <UpperTheta>55</UpperTheta>
512 <                                </ThetaBounds>
513 <                                </AngleBasisBlock>
514 <                                <AngleBasisBlock>
515 <                                <Theta>60</Theta>
516 <                                <nPhis>24</nPhis>
517 <                                <ThetaBounds>
518 <                                        <LowerTheta>55</LowerTheta>
519 <                                        <UpperTheta>65</UpperTheta>
520 <                                </ThetaBounds>
521 <                                </AngleBasisBlock>
522 <                                <AngleBasisBlock>
523 <                                <Theta>70</Theta>
524 <                                <nPhis>16</nPhis>
525 <                                <ThetaBounds>
526 <                                        <LowerTheta>65</LowerTheta>
527 <                                        <UpperTheta>75</UpperTheta>
528 <                                </ThetaBounds>
529 <                                </AngleBasisBlock>
530 <                                <AngleBasisBlock>
531 <                                <Theta>82.5</Theta>
532 <                                <nPhis>12</nPhis>
533 <                                <ThetaBounds>
534 <                                        <LowerTheta>75</LowerTheta>
535 <                                        <UpperTheta>90</UpperTheta>
536 <                                </ThetaBounds>
537 <                        </AngleBasisBlock>
538 <                </AngleBasis>
539 <        </DataDefinition>
540 < ';
541 < if ( $doforw ) {
542 < print
543 < '       <WavelengthData>
544 <                <LayerNumber>System</LayerNumber>
545 <                <Wavelength unit="Integral">Visible</Wavelength>
546 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
547 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
548 <                <WavelengthDataBlock>
549 <                        <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
550 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
551 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
552 <                        <ScatteringDataType>BTDF</ScatteringDataType>
553 <                        <ScatteringData>
554 < ';
555 < # Output front transmission (transposed order)
556 < for (my $od = 0; $od < $ndiv; $od++) {
557 <        for (my $id = 0; $id < $ndiv; $id++) {
558 <                print $tfarr[$ndiv*$id + $od];
457 >
458 >        # Run rfluxmtx processes to compute each side
459 >        do_matrix_dir(0) if ( $doback );
460 >        do_matrix_dir(1) if ( $doforw );
461 >
462 > }       # end of sub do_matrix_bsdf()
463 >
464 > # Call rfluxmtx and process tensor tree BSDF for the given direction
465 > sub do_matrix_dir {
466 >        my $forw = shift;
467 >        my $r = do_phase();
468 >        if (!$r) { return; }
469 >        $r = ($r < 0) ? " -r" : "";
470 >        my $cmd;
471 >        my $sender = ($bsender,$fsender)[$forw];
472 >        $cmd = "$rfluxmtx$r -fd $sender $receivers -i $octree";
473 >        # print STDERR "Starting: $cmd\n";
474 >        system $cmd;
475 >        die "Failure running rfluxmtx" if ( $? );
476 >        matrix_out($forw);
477 > }       # end of do_matrix_dir()
478 >
479 > sub matrix_out {
480 >        my $forw = shift;
481 >        my ($refldat,$transdat);
482 >        if ( $forw ) {
483 >                $transdat = $facedat;
484 >                $refldat = $behinddat;
485 >        } else {
486 >                $transdat = $behinddat;
487 >                $refldat = $facedat;
488          }
489 <        print "\n";
490 < }
491 < print
492 < '                       </ScatteringData>
493 <                </WavelengthDataBlock>
494 <        </WavelengthData>
566 <        <WavelengthData>
567 <                <LayerNumber>System</LayerNumber>
568 <                <Wavelength unit="Integral">Visible</Wavelength>
569 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
570 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
571 <                <WavelengthDataBlock>
572 <                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
573 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
574 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
575 <                        <ScatteringDataType>BRDF</ScatteringDataType>
576 <                        <ScatteringData>
577 < ';
578 < # Output front reflection (transposed order)
579 < for (my $od = 0; $od < $ndiv; $od++) {
580 <        for (my $id = 0; $id < $ndiv; $id++) {
581 <                print $rfarr[$ndiv*$id + $od];
489 >        # Output transmission
490 >        my $ttyp = ("tb","tf")[$forw];
491 >        matrix_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
492 >        if ( $docolor ) {
493 >                matrix_comp($ttyp, "CIE-X", $transdat, ($tbx,$tfx)[$forw]);
494 >                matrix_comp($ttyp, "CIE-Z", $transdat, ($tbz,$tfz)[$forw]);
495          }
496 <        print "\n";
497 < }
498 < print
499 < '                       </ScatteringData>
500 <                </WavelengthDataBlock>
501 <        </WavelengthData>
589 < ';
590 < }
591 < if ( $doback ) {
592 < print
593 < '       <WavelengthData>
594 <                <LayerNumber>System</LayerNumber>
595 <                <Wavelength unit="Integral">Visible</Wavelength>
596 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
597 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
598 <                <WavelengthDataBlock>
599 <                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
600 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
601 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
602 <                        <ScatteringDataType>BTDF</ScatteringDataType>
603 <                        <ScatteringData>
604 < ';
605 < # Output back transmission (transposed order)
606 < for (my $od = 0; $od < $ndiv; $od++) {
607 <        for (my $id = 0; $id < $ndiv; $id++) {
608 <                print $tbarr[$ndiv*$id + $od];
496 >        # Output reflection
497 >        my $rtyp = ("rb","rf")[$forw];
498 >        matrix_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
499 >        if ( $docolor ) {
500 >                matrix_comp($rtyp, "CIE-X", $refldat, ($rbx,$rfx)[$forw]);
501 >                matrix_comp($rtyp, "CIE-Z", $refldat, ($rbz,$rfz)[$forw]);
502          }
503 <        print "\n";
504 < }
505 < print
506 < '                       </ScatteringData>
507 <                </WavelengthDataBlock>
508 <        </WavelengthData>
509 <        <WavelengthData>
510 <                <LayerNumber>System</LayerNumber>
511 <                <Wavelength unit="Integral">Visible</Wavelength>
512 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
513 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
514 <                <WavelengthDataBlock>
515 <                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
516 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
517 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
625 <                        <ScatteringDataType>BRDF</ScatteringDataType>
626 <                        <ScatteringData>
627 < ';
628 < # Output back reflection (transposed order)
629 < for (my $od = 0; $od < $ndiv; $od++) {
630 <        for (my $id = 0; $id < $ndiv; $id++) {
631 <                print $rbarr[$ndiv*$id + $od];
503 > }       # end of matrix_out()
504 >
505 > # Transpose matrix component data and save to file
506 > sub matrix_comp {
507 >        my $typ = shift;
508 >        my $spec = shift;
509 >        my $src = shift;
510 >        my $dest = shift;
511 >        my $cmd = "rmtxop -fa -t";
512 >        if ("$spec" eq "Visible") {
513 >                $cmd .= " -c 0.2651 0.6701 0.0648";
514 >        } elsif ("$spec" eq "CIE-X") {
515 >                $cmd .= " -c 0.5141 0.3239 0.1620";
516 >        } elsif ("$spec" eq "CIE-Z") {
517 >                $cmd .= " -c 0.0241 0.1229 0.8530";
518          }
519 <        print "\n";
520 < }
521 < print
522 < '                       </ScatteringData>
523 <                </WavelengthDataBlock>
524 <        </WavelengthData>
525 < ';
526 < }
527 < }
528 < #------------- End of do_matrix_bsdf() --------------#
519 >        $cmd .= " $src | rcollate -ho -oc 145";
520 >        # print STDERR "Running: $cmd\n";
521 >        system "$cmd > $dest";
522 >        die "Failure running rmtxop" if ( $? );
523 >        if ( "$spec" ne "$curspec" ) {
524 >                $wrapper .= " -s $spec";
525 >                $curspec = $spec;
526 >        }
527 >        $wrapper .= " -$typ $dest";
528 > }       # end of matrix_comp()
529 >
530 > #------------- End of do_matrix_bsdf() & subroutines --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines